#import "/musr/H/ugens.h"
#import "cmixTransport.h"
#import <objc/objc.h>
#import <sys/file.h>
#import "/musr/H/sfheader.h"

extern char *sfname[NFILES];
extern int sfd[NFILES];
extern SFHEADER      sfdesc[NFILES];
int oncode[6];
float timelist[6];
float timearray[6];
id myTransport,mySound,mySound2;

#define ARRAY_SIZE 1024
float array1[ARRAY_SIZE],array2[ARRAY_SIZE],tablestuff1[2],tablestuff2[2],gain1,gain2;extern int frames_to_do,currenttime,samples_to_do;
int file1offset,file2offset,overall_offset,file1,file2,nbuffers;
int pan1set,pan2set;
float pan1valleft,pan1valright,pan2valleft,pan2valright;

int NBYTES = 32768;

double playmix(p,n_args)
float *p;
int n_args;
{
	int error,nsamples,pos1,pos2,i;
	short dummy,*fdap,*fdbp;
	myTransport = [Transport new];
	mySound = [Sound new];
	mySound2 = [Sound new];
	/* p0=skipin1,p1=endin1,p2=startplay1,p3=skipin2,p4=endin2,p5=startplay2 */
	if(error = [mySound  readSoundfile:sfname[0]]) die(error);
	if(error = [mySound2 readSoundfile:sfname[1]]) die(error);
	
	/*********************************************
	   try to touch file pages, to read into virtual memory
		fdap = (short *)[mySound data];
	fdbp = (short *)[mySound2 data];
	for(dummy=i=0; i<[mySound sampleCount]; i += 32768)
		dummy = fdap[i];
	for(i=0; i<[mySound2 sampleCount]; i += 32768)
		dummy = fdbp[i];
	printf("dummy=%d\n",dummy);
	**************************************************/
	
	setnote(timearray[0],timearray[1]-timearray[0],file1);
	_backup(file1);
	setnote(timearray[3],timearray[4]-timearray[3],file2);
 	_backup(file2);

	timeparse(timearray,timelist,oncode,SR);
	if(p[1])
		timelist[4]=frames_to_do=p[1]*SR;
	else frames_to_do=timelist[4];

	if(p[0]) {	
		if(p[0] > timearray[2])
		 pos1=lseek(sfd[0],
	          (int)((p[0]-timearray[2])*SR*sfchans(&sfdesc[0]))*2,L_INCR);
		if(p[0] > timearray[5]) 
		 pos2=lseek(sfd[1],
	           (int)((p[0]-timearray[5])*SR*sfchans(&sfdesc[1]))*2,L_INCR);
		frames_to_do -= p[0]*SR;
	}
  	samples_to_do=frames_to_do * 2; /* always stereo output */
	[myTransport tplay:(id)mySound with:(id)mySound2
		bufcount:(int)nbuffers];
	[myTransport wait];
	[mySound free]; [mySound2 free];
}

die(error)
{
	printf("%s\n",SNDSoundError(error));
	exit(-1);
}
double ofile1(p,n_args)
float *p;
{
	double _dur();
	float dummy = 0;
	if(p[2] < 0.) p[2] = p[1] - p[2];
	if(p[2] > _dur(&dummy)) p[2]=_dur(&dummy);
	timearray[0]=p[0]; timearray[1]=p[2]; timearray[2]=p[1];
	tableset(timearray[1]-timearray[0],ARRAY_SIZE,tablestuff1);
	file1offset = - timearray[2] * SR;
	}
double ofile2(p,n_args)
float *p;
{
	double _dur();
	float dummy = 1;
	if(p[2] < 0.) p[2] = p[1] - p[2];
	if(p[2] > _dur(&dummy)) p[2]=_dur(&dummy);
	timearray[3]=p[0]; timearray[4]=p[2]; timearray[5]=p[1];
	tableset(timearray[4]-timearray[3],ARRAY_SIZE,tablestuff2);
	file2offset = - timearray[5] * SR;
}
double setline1(p,n_args)
float *p;
{
	setline(p,n_args,ARRAY_SIZE,array1);
}

double setline2(p,n_args)
float *p;
{	
	setline(p,n_args,ARRAY_SIZE,array2);
}
double openfile1(p,n_args)
float *p;
{
	p[1]=0;
	m_open(p,n_args);
}
double openfile2(p,n_args)
float *p;
{
	p[1]=1;
	m_open(p,n_args);
}
double stuff(p,n_args)
float *p;
{
	nbuffers=p[0]; gain1=p[1]; gain2=p[2];
	printf("nbuffers=%d, gain1=%f, gain2=%f\n",nbuffers,gain1,gain2);
}

double pan1(p,n_args)
float *p;
{	if(n_args == 0) pan1set = 0;
	else {
		 pan1set = 1; 
		 pan1valleft=p[0]; 
		 pan1valright = 1.-p[0]; 
	}
}
double pan2(p,n_args)
float *p;
{ 	if(n_args == 0) pan2set = 0; 
	else {
		pan2set = 1;
		pan2valleft=p[0]; 
		pan2valright=1.-p[0]; 
	}
}
profile()
{
	int i;
	UG_INTRO("stuff",stuff);
	UG_INTRO("playmix",playmix);
	UG_INTRO("setfile1",ofile1);
	UG_INTRO("setfile2",ofile2);
	UG_INTRO("setline1",setline1);
	UG_INTRO("setline2",setline2);
	UG_INTRO("openfile1",openfile1);
	UG_INTRO("openfile2",openfile2);
	UG_INTRO("pan1",pan1);
	UG_INTRO("pan2",pan2);
	pan1set=pan2set=0;

	file1=0; file2=1;
	for(i=0; i<ARRAY_SIZE; i++) array1[i]=array2[i]=1.;
	fixstack();  /* readjust stacksize */
}
